## ros-iron-popf 0.0.15

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project (popf) 

find_package(ament_cmake REQUIRED)
set(dependencies
    rclcpp
)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

set( CMAKE_MODULE_PATH    ${CMAKE_MODULE_PATH}
                          ${CMAKE_CURRENT_SOURCE_DIR}/src/cmake/modules)

find_package(Clp)
find_package(CoinUtils)
find_package(Cbc)
find_package(Cgl)

set(val_SOURCE_DIR src/VALfiles)
set(popf_SOURCE_DIR src/popf)
set(parsePDDL_SOURCE_DIR ${val_SOURCE_DIR}/parsing)

include_directories(
  ${popf_SOURCE_DIR}
  ${val_SOURCE_DIR} 
  ${parsePDDL_SOURCE_DIR}
  ${val_BINARY_DIR} 
  ${CLP_INCLUDES}/coin
  ${CBC_INCLUDES}/coin  
  ${CPLEX_INCLUDES} 
  ${CONCERT_INCLUDES}
)

## ParsePDDL

find_program(BISON_EXECUTABLE bison)

if(NOT EXISTS ${BISON_EXECUTABLE})
	message("Could not find bison executable.")
endif(NOT EXISTS ${BISON_EXECUTABLE})

FIND_PROGRAM(FLEX_EXECUTABLE flex)

if(NOT EXISTS ${FLEX_EXECUTABLE})
        message("Could not find flex executable.")
endif(NOT EXISTS ${FLEX_EXECUTABLE})

add_custom_command(
       OUTPUT
        ${CMAKE_CURRENT_BINARY_DIR}/lex.yy.cc
       COMMAND
        ${FLEX_EXECUTABLE}
       ARGS
       -+  --outfile=${CMAKE_CURRENT_BINARY_DIR}/lex.yy.cc ${CMAKE_CURRENT_SOURCE_DIR}/${parsePDDL_SOURCE_DIR}/pddl+.lex
       DEPENDS
        ${CMAKE_CURRENT_SOURCE_DIR}/${parsePDDL_SOURCE_DIR}/pddl+.lex
)

add_custom_command(
       OUTPUT
        ${CMAKE_CURRENT_BINARY_DIR}/pddl+.cpp
       COMMAND
        ${BISON_EXECUTABLE}
       ARGS
        ${CMAKE_CURRENT_SOURCE_DIR}/${parsePDDL_SOURCE_DIR}/pddl+.yacc -o ${CMAKE_CURRENT_BINARY_DIR}/pddl+.cpp
       DEPENDS
        ${CMAKE_CURRENT_SOURCE_DIR}/${parsePDDL_SOURCE_DIR}/pddl+.yacc ${CMAKE_CURRENT_BINARY_DIR}/lex.yy.cc
       COMMAND
        ${CMAKE_CURRENT_SOURCE_DIR}/${parsePDDL_SOURCE_DIR}/fixyywrap ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/${parsePDDL_SOURCE_DIR}/
)

set(libParsePDDL_SRCS
      ${CMAKE_CURRENT_BINARY_DIR}/pddl+.cpp
      ${parsePDDL_SOURCE_DIR}/ptree.cpp
      ${parsePDDL_SOURCE_DIR}/DebugWriteController.cpp
)

add_library(ParsePDDL SHARED ${libParsePDDL_SRCS})

## Val

set(libInst_SRCS
      ${val_SOURCE_DIR}/SimpleEval.cpp
      ${val_SOURCE_DIR}/FastEnvironment.cpp
      ${val_SOURCE_DIR}/instantiation.cpp
      ${val_SOURCE_DIR}/typecheck.cpp
      ${val_SOURCE_DIR}/TypedAnalyser.cpp
      ${val_SOURCE_DIR}/FuncAnalysis.cpp
      ${val_SOURCE_DIR}/TIM.cpp 
      ${val_SOURCE_DIR}/TimSupport.cpp 
      ${val_SOURCE_DIR}/TypeStripWC.cpp
)

add_library(Inst SHARED ${libInst_SRCS})
target_link_libraries(Inst ParsePDDL)

set(validate_SRCS
     ${val_SOURCE_DIR}/Action.cpp 
     ${val_SOURCE_DIR}/Proposition.cpp 
     ${val_SOURCE_DIR}/FuncExp.cpp 
     ${val_SOURCE_DIR}/typecheck.cpp 
     ${val_SOURCE_DIR}/main.cpp
     ${val_SOURCE_DIR}/Validator.cpp 
     ${val_SOURCE_DIR}/RepairAdvice.cpp 
     ${val_SOURCE_DIR}/LaTeXSupport.cpp 
     ${val_SOURCE_DIR}/State.cpp 
     ${val_SOURCE_DIR}/Plan.cpp 
     ${val_SOURCE_DIR}/Ownership.cpp
     ${val_SOURCE_DIR}/Environment.cpp 
     ${val_SOURCE_DIR}/Polynomial.cpp 
     ${val_SOURCE_DIR}/Utils.cpp
     ${val_SOURCE_DIR}/TrajectoryConstraints.cpp 
     ${val_SOURCE_DIR}/RobustAnalyse.cpp 
     ${val_SOURCE_DIR}/random.cpp 
     ${val_SOURCE_DIR}/Events.cpp 
     ${val_SOURCE_DIR}/PrettyPrinter.cpp)
     
add_executable(validate ${validate_SRCS})

target_link_libraries(validate
  ParsePDDL
)

set(parser_SRCS
     ${val_SOURCE_DIR}/parse.cpp
)

add_executable(parser ${parser_SRCS})

target_link_libraries(parser
        ParsePDDL
)

install(TARGETS validate parser ParsePDDL
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

## Popf

set(popf_build_srcs
    ${popf_SOURCE_DIR}/totalordertransformer.cpp
    ${popf_SOURCE_DIR}/partialordertransformer.cpp
    ${popf_SOURCE_DIR}/FFSolver.cpp
    ${popf_SOURCE_DIR}/globals.cpp
    ${popf_SOURCE_DIR}/lpscheduler.cpp
    ${popf_SOURCE_DIR}/RPGBuilder.cpp
    ${popf_SOURCE_DIR}/RPGBuilderAnalysis.cpp
    ${popf_SOURCE_DIR}/RPGBuilderEvaluation.cpp
    ${popf_SOURCE_DIR}/RPGBuilderNumerics.cpp
    ${popf_SOURCE_DIR}/temporalanalysis.cpp
    ${popf_SOURCE_DIR}/minimalstate.cpp
    ${popf_SOURCE_DIR}/temporalconstraints.cpp
    ${popf_SOURCE_DIR}/numericanalysis.cpp
    ${popf_SOURCE_DIR}/solver.cpp
    ${popf_SOURCE_DIR}/solver-clp.cpp
    ${popf_SOURCE_DIR}/Popf.cpp)

add_library(popfCommon SHARED ${popf_build_srcs})
target_link_libraries(popfCommon ParsePDDL Inst)

install(TARGETS popfCommon ParsePDDL Inst
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

ADD_EXECUTABLE(popf ${popf_SOURCE_DIR}/popfMain.cpp)
target_link_libraries(popf
  popfCommon
  ${CBC_LIBRARY} ${CGL_LIBRARIES} ${CLP_LIBRARIES}  ${COINUTILS_LIBRARIES}
)
install(TARGETS popf
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

install(FILES src/popf/Popf.hpp
  DESTINATION include/popf
)

ament_export_include_directories(include)
ament_export_libraries(popfCommon ParsePDDL Inst ${CBC_LIBRARY} ${CGL_LIBRARIES} ${OSICLP_LIBRARIES} ${OSI_LIBRARIES} ${CLP_LIBRARIES}  ${COINUTILS_LIBRARIES})
ament_export_dependencies(${dependencies})
ament_package()

=== debian/changelog ===
ros-iron-popf (0.0.15-1jammy) jammy; urgency=high



 -- Francisco Martin <fmrico@gmail.com>  Fri, 14 Jul 2023 22:00:00 -0000

ros-iron-popf (0.0.14-1jammy) jammy; urgency=high

  * Checking null problem components
  * Contributors: Francisco Martín Rico

 -- Francisco Martin <fmrico@gmail.com>  Thu, 26 May 2022 22:00:00 -0000

ros-iron-popf (0.0.13-1jammy) jammy; urgency=high



 -- Francisco Martin <fmrico@gmail.com>  Fri, 02 Jul 2021 22:00:00 -0000

ros-iron-popf (0.0.12-1jammy) jammy; urgency=high

  * Foxy initial version
  * Fix conflicts in changelog
  * Functional version
  * 0.0.3
  * Updated changelog
  * Contributors: Francisco Martin Rico

 -- Francisco Martin <fmrico@gmail.com>  Fri, 17 Jul 2020 22:00:00 -0000

ros-iron-popf (0.0.11-1jammy) jammy; urgency=high

  * Added dependencies to package.xml

 -- Francisco Martin <fmrico@gmail.com>  Thu, 19 Dec 2019 23:00:00 -0000

ros-iron-popf (0.0.10-1jammy) jammy; urgency=high

  * Added dependencies to package.xml

 -- Francisco Martin <fmrico@gmail.com>  Thu, 19 Dec 2019 23:00:00 -0000

ros-iron-popf (0.0.6-1jammy) jammy; urgency=high



 -- Francisco Martin <fmrico@gmail.com>  Thu, 19 Dec 2019 23:00:00 -0000

ros-iron-popf (0.0.5-1jammy) jammy; urgency=high

  * Fixing package dependencies
    Signed-off-by: Francisco Martin Rico <mailto:fmrico@gmail.com>

 -- Francisco Martin <fmrico@gmail.com>  Thu, 19 Dec 2019 23:00:00 -0000

ros-iron-popf (0.0.3-1jammy) jammy; urgency=high

  * Fix packaging errors

 -- Francisco Martin <fmrico@gmail.com>  Thu, 19 Dec 2019 23:00:00 -0000

ros-iron-popf (0.0.2-1jammy) jammy; urgency=high

  * Update to ROS2
  * Use as library

 -- Francisco Martin <fmrico@gmail.com>  Fri, 06 Dec 2019 23:00:00 -0000

ros-iron-popf (0.0.1-1jammy) jammy; urgency=high

  * Update package.xml
  * tidy up
  * Merge branch 'master' of https://github.com/LCAS/popf
  * Initial commit
  * popf 1 included and made work
  * initial commit
  * Contributors: Marc Hanheide

 -- Francisco Martin <fmrico@gmail.com>  Mon, 25 Apr 2016 22:00:00 -0000

=== debian/control ===
Source: ros-iron-popf
Section: misc
Priority: optional
Maintainer: Francisco Martin <fmrico@gmail.com>
Build-Depends: debhelper (>= 9.0.0), bison, coinor-libcbc-dev, coinor-libcgl-dev, coinor-libclp-dev, coinor-libcoinutils-dev, flex, ros-iron-ament-cmake, ros-iron-rclcpp, ros-iron-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-iron-popf
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, bison, coinor-libcbc-dev, coinor-libcgl-dev, coinor-libclp-dev, coinor-libcoinutils-dev, flex, ros-iron-rclcpp, ros-iron-ros-workspace
Description: The POPF package

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-popf//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
